Attribute VB_Name = "modSorters"
' Various sorting routines here, adapted from code by Bruno Santos
' At some point, should perform some better abstractions to share
' the same sorting routine for multiple types of data...

Option Explicit
Option Compare Text


Public Sub sortFeatures(ByRef featString As Variant, ByRef featPercent As Variant, primero As Long, ultimo As Long)
' Adaptacin del cdigo de:
' Bruno Barreiro Santos
' brunobs@interbook.net
    Dim i As Long
    Dim last As Long
    Dim temp As Variant
    Dim sTemp As Variant
    
    If primero >= ultimo Then Exit Sub
    'Swap featPercent, primero, (primero + ultimo) \ 2
    temp = featPercent(primero)
    sTemp = featString(primero)
    featPercent(primero) = featPercent((primero + ultimo) \ 2)
    featPercent((primero + ultimo) \ 2) = temp
    featString(primero) = featString((primero + ultimo) \ 2)
    featString((primero + ultimo) \ 2) = sTemp
    last = primero
    i = primero
    Do While i <= ultimo
    If featPercent(i) > featPercent(primero) Then
        last = last + 1
        'Swap featPercent, Last, i
        temp = featPercent(last)
        featPercent(last) = featPercent(i)
        featPercent(i) = temp
        sTemp = featString(last)
        featString(last) = featString(i)
        featString(i) = sTemp
    End If
    i = i + 1
    Loop
    'Swap featPercent, primero, Last
    temp = featPercent(primero)
    featPercent(primero) = featPercent(last)
    featPercent(last) = temp
    sTemp = featString(primero)
    featString(primero) = featString(last)
    featString(last) = sTemp
    sortFeatures featString, featPercent, primero, last - 1
    sortFeatures featString, featPercent, last + 1, ultimo
    DoEvents
End Sub

Public Sub sortRelevance(ByRef featTitle() As String, ByRef featURL() As String, ByRef featPercent() As Single, primero As Long, ultimo As Long)
' Adaptacin del cdigo de:
' Bruno Barreiro Santos
' brunobs@interbook.net
    Dim i As Long
    Dim last As Long
    Dim temp As Single
    Dim sTemp As String
    Dim sTemp2 As String
    
    If primero >= ultimo Then Exit Sub
    'Swap featPercent, primero, (primero + ultimo) \ 2
    temp = featPercent(primero)
    sTemp = featTitle(primero)
    sTemp2 = featURL(primero)
    featPercent(primero) = featPercent((primero + ultimo) \ 2)
    featPercent((primero + ultimo) \ 2) = temp
    featTitle(primero) = featTitle((primero + ultimo) \ 2)
    featTitle((primero + ultimo) \ 2) = sTemp
    featURL(primero) = featURL((primero + ultimo) \ 2)
    featURL((primero + ultimo) \ 2) = sTemp2
    last = primero
    i = primero
    Do While i <= ultimo
    If featPercent(i) > featPercent(primero) Then
        last = last + 1
        'Swap featPercent, Last, i
        temp = featPercent(last)
        featPercent(last) = featPercent(i)
        featPercent(i) = temp
        sTemp = featTitle(last)
        featTitle(last) = featTitle(i)
        featTitle(i) = sTemp
        sTemp2 = featURL(last)
        featURL(last) = featURL(i)
        featURL(i) = sTemp2
    End If
    i = i + 1
    Loop
    'Swap featPercent, primero, Last
    temp = featPercent(primero)
    featPercent(primero) = featPercent(last)
    featPercent(last) = temp
    sTemp = featTitle(primero)
    featTitle(primero) = featTitle(last)
    featTitle(last) = sTemp
    sTemp2 = featURL(primero)
    featURL(primero) = featURL(last)
    featURL(last) = sTemp2
    sortRelevance featTitle, featURL, featPercent, primero, last - 1
    sortRelevance featTitle, featURL, featPercent, last + 1, ultimo
    DoEvents
End Sub
